<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=emulateIE7" />
    <title>Coverage for test_codegen.py: 82%</title>
    <link rel="stylesheet" href="style.css" type="text/css">
    <script type="text/javascript" src="jquery.min.js"></script>
    <script type="text/javascript" src="jquery.hotkeys.js"></script>
    <script type="text/javascript" src="jquery.isonscreen.js"></script>
    <script type="text/javascript" src="coverage_html.js"></script>
    <script type="text/javascript">
        jQuery(document).ready(coverage.pyfile_ready);
    </script>
</head>
<body class="pyfile">
<div id="header">
    <div class="content">
        <h1>Coverage for <b>test_codegen.py</b> :
            <span class="pc_cov">82%</span>
        </h1>
        <img id="keyboard_icon" src="keybd_closed.png" alt="Show keyboard shortcuts" />
        <h2 class="stats">
            141 statements &nbsp;
            <span class="run shortkey_r button_toggle_run">115 run</span>
            <span class="mis show_mis shortkey_m button_toggle_mis">26 missing</span>
            <span class="exc show_exc shortkey_x button_toggle_exc">0 excluded</span>
        </h2>
    </div>
</div>
<div class="help_panel">
    <img id="panel_icon" src="keybd_open.png" alt="Hide keyboard shortcuts" />
    <p class="legend">Hot-keys on this page</p>
    <div>
    <p class="keyhelp">
        <span class="key">r</span>
        <span class="key">m</span>
        <span class="key">x</span>
        <span class="key">p</span> &nbsp; toggle line displays
    </p>
    <p class="keyhelp">
        <span class="key">j</span>
        <span class="key">k</span> &nbsp; next/prev highlighted chunk
    </p>
    <p class="keyhelp">
        <span class="key">0</span> &nbsp; (zero) top of page
    </p>
    <p class="keyhelp">
        <span class="key">1</span> &nbsp; (one) first highlighted chunk
    </p>
    </div>
</div>
<div id="source">
    <p id="t1" class="pln"><span class="n"><a href="#t1">1</a></span><span class="t"><span class="com">#! /usr/bin/env python3</span>&nbsp;</span><span class="r"></span></p>
    <p id="t2" class="pln"><span class="n"><a href="#t2">2</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t3" class="run"><span class="n"><a href="#t3">3</a></span><span class="t"><span class="key">import</span> <span class="nam">os</span>&nbsp;</span><span class="r"></span></p>
    <p id="t4" class="run"><span class="n"><a href="#t4">4</a></span><span class="t"><span class="key">import</span> <span class="nam">sys</span>&nbsp;</span><span class="r"></span></p>
    <p id="t5" class="run"><span class="n"><a href="#t5">5</a></span><span class="t"><span class="key">import</span> <span class="nam">pytest</span>&nbsp;</span><span class="r"></span></p>
    <p id="t6" class="run"><span class="n"><a href="#t6">6</a></span><span class="t"><span class="key">import</span> <span class="nam">glob</span>&nbsp;</span><span class="r"></span></p>
    <p id="t7" class="run"><span class="n"><a href="#t7">7</a></span><span class="t"><span class="key">import</span> <span class="nam">subprocess</span>&nbsp;</span><span class="r"></span></p>
    <p id="t8" class="run"><span class="n"><a href="#t8">8</a></span><span class="t"><span class="key">import</span> <span class="nam">re</span>&nbsp;</span><span class="r"></span></p>
    <p id="t9" class="run"><span class="n"><a href="#t9">9</a></span><span class="t"><span class="key">from</span> <span class="nam">test_expect_pragma</span> <span class="key">import</span> <span class="op">(</span>&nbsp;</span><span class="r"></span></p>
    <p id="t10" class="pln"><span class="n"><a href="#t10">10</a></span><span class="t">    <span class="nam">TestExpectPragmas</span><span class="op">,</span> <span class="nam">cat</span><span class="op">,</span> <span class="nam">testinfo</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t11" class="pln"><span class="n"><a href="#t11">11</a></span><span class="t">    <span class="nam">env_bool_variable</span><span class="op">,</span> <span class="nam">env_str_variable</span>&nbsp;</span><span class="r"></span></p>
    <p id="t12" class="pln"><span class="n"><a href="#t12">12</a></span><span class="t">    <span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t13" class="pln"><span class="n"><a href="#t13">13</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t14" class="pln"><span class="n"><a href="#t14">14</a></span><span class="t"><span class="str">"""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t15" class="pln"><span class="n"><a href="#t15">15</a></span><span class="t"><span class="str">Usage:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t16" class="pln"><span class="n"><a href="#t16">16</a></span><span class="t"><span class="str">    python3 test_codegen.py</span>&nbsp;</span><span class="r"></span></p>
    <p id="t17" class="pln"><span class="n"><a href="#t17">17</a></span><span class="t"><span class="str">(or make tests)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t18" class="pln"><span class="n"><a href="#t18">18</a></span><span class="t"><span class="str">"""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t19" class="pln"><span class="n"><a href="#t19">19</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t20" class="pln"><span class="n"><a href="#t20">20</a></span><span class="t"><span class="str">"""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t21" class="pln"><span class="n"><a href="#t21">21</a></span><span class="t"><span class="str">MIF08 and CAP, 2019</span>&nbsp;</span><span class="r"></span></p>
    <p id="t22" class="pln"><span class="n"><a href="#t22">22</a></span><span class="t"><span class="str">Unit test infrastructure for testing code generation:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t23" class="pln"><span class="n"><a href="#t23">23</a></span><span class="t"><span class="str">1) compare the actual output to the expected one (in comments)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t24" class="pln"><span class="n"><a href="#t24">24</a></span><span class="t"><span class="str">2) compare the actual output to the one obtained by simulation</span>&nbsp;</span><span class="r"></span></p>
    <p id="t25" class="pln"><span class="n"><a href="#t25">25</a></span><span class="t"><span class="str">3) for different allocation algorithms</span>&nbsp;</span><span class="r"></span></p>
    <p id="t26" class="pln"><span class="n"><a href="#t26">26</a></span><span class="t"><span class="str">"""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t27" class="pln"><span class="n"><a href="#t27">27</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t28" class="run"><span class="n"><a href="#t28">28</a></span><span class="t"><span class="nam">DISABLE_TYPECHECK</span> <span class="op">=</span> <span class="key">True</span>&nbsp;</span><span class="r"></span></p>
    <p id="t29" class="run"><span class="n"><a href="#t29">29</a></span><span class="t"><span class="nam">TYPECHECK_ONLY</span> <span class="op">=</span> <span class="key">False</span>&nbsp;</span><span class="r"></span></p>
    <p id="t30" class="pln"><span class="n"><a href="#t30">30</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t31" class="run"><span class="n"><a href="#t31">31</a></span><span class="t"><span class="nam">HERE</span> <span class="op">=</span> <span class="nam">os</span><span class="op">.</span><span class="nam">path</span><span class="op">.</span><span class="nam">dirname</span><span class="op">(</span><span class="nam">os</span><span class="op">.</span><span class="nam">path</span><span class="op">.</span><span class="nam">realpath</span><span class="op">(</span><span class="nam">__file__</span><span class="op">)</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t32" class="run"><span class="n"><a href="#t32">32</a></span><span class="t"><span class="key">if</span> <span class="nam">HERE</span> <span class="op">==</span> <span class="nam">os</span><span class="op">.</span><span class="nam">path</span><span class="op">.</span><span class="nam">realpath</span><span class="op">(</span><span class="str">'.'</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t33" class="run"><span class="n"><a href="#t33">33</a></span><span class="t">    <span class="nam">HERE</span> <span class="op">=</span> <span class="str">'.'</span>&nbsp;</span><span class="r"></span></p>
    <p id="t34" class="run"><span class="n"><a href="#t34">34</a></span><span class="t"><span class="nam">TEST_DIR</span> <span class="op">=</span> <span class="nam">HERE</span>&nbsp;</span><span class="r"></span></p>
    <p id="t35" class="run"><span class="n"><a href="#t35">35</a></span><span class="t"><span class="nam">IMPLEM_DIR</span> <span class="op">=</span> <span class="nam">HERE</span>&nbsp;</span><span class="r"></span></p>
    <p id="t36" class="run"><span class="n"><a href="#t36">36</a></span><span class="t"><span class="nam">MINIC_COMPILE</span> <span class="op">=</span> <span class="nam">os</span><span class="op">.</span><span class="nam">path</span><span class="op">.</span><span class="nam">join</span><span class="op">(</span><span class="nam">IMPLEM_DIR</span><span class="op">,</span> <span class="str">'Main.py'</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t37" class="pln"><span class="n"><a href="#t37">37</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t38" class="run"><span class="n"><a href="#t38">38</a></span><span class="t"><span class="nam">ALL_FILES</span> <span class="op">=</span> <span class="nam">glob</span><span class="op">.</span><span class="nam">glob</span><span class="op">(</span><span class="str">'./tests*/**/[a-zA-Z]*.c'</span><span class="op">,</span> <span class="nam">recursive</span><span class="op">=</span><span class="key">True</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t39" class="run"><span class="n"><a href="#t39">39</a></span><span class="t"><span class="key">if</span> <span class="str">'TEST_FILES'</span> <span class="key">in</span> <span class="nam">os</span><span class="op">.</span><span class="nam">environ</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t40" class="mis show_mis"><span class="n"><a href="#t40">40</a></span><span class="t">    <span class="nam">ALL_FILES</span> <span class="op">=</span> <span class="nam">glob</span><span class="op">.</span><span class="nam">glob</span><span class="op">(</span><span class="nam">os</span><span class="op">.</span><span class="nam">environ</span><span class="op">[</span><span class="str">'TEST_FILES'</span><span class="op">]</span><span class="op">,</span> <span class="nam">recursive</span><span class="op">=</span><span class="key">True</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t41" class="pln"><span class="n"><a href="#t41">41</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t42" class="run"><span class="n"><a href="#t42">42</a></span><span class="t"><span class="nam">ALLOC_FILES</span> <span class="op">=</span> <span class="nam">glob</span><span class="op">.</span><span class="nam">glob</span><span class="op">(</span><span class="nam">HERE</span> <span class="op">+</span> <span class="str">'/testsdataflow/*.c'</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t43" class="pln"><span class="n"><a href="#t43">43</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t44" class="run"><span class="n"><a href="#t44">44</a></span><span class="t"><span class="nam">ASM</span> <span class="op">=</span> <span class="str">'riscv64-unknown-elf-gcc'</span>&nbsp;</span><span class="r"></span></p>
    <p id="t45" class="run"><span class="n"><a href="#t45">45</a></span><span class="t"><span class="nam">SIMU</span> <span class="op">=</span> <span class="str">'spike'</span>&nbsp;</span><span class="r"></span></p>
    <p id="t46" class="pln"><span class="n"><a href="#t46">46</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t47" class="run"><span class="n"><a href="#t47">47</a></span><span class="t"><span class="nam">SKIP_NOT_IMPLEMENTED</span> <span class="op">=</span> <span class="key">False</span>&nbsp;</span><span class="r"></span></p>
    <p id="t48" class="run"><span class="n"><a href="#t48">48</a></span><span class="t"><span class="key">if</span> <span class="str">'SKIP_NOT_IMPLEMENTED'</span> <span class="key">in</span> <span class="nam">os</span><span class="op">.</span><span class="nam">environ</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t49" class="mis show_mis"><span class="n"><a href="#t49">49</a></span><span class="t">    <span class="nam">SKIP_NOT_IMPLEMENTED</span> <span class="op">=</span> <span class="key">True</span>&nbsp;</span><span class="r"></span></p>
    <p id="t50" class="pln"><span class="n"><a href="#t50">50</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t51" class="run"><span class="n"><a href="#t51">51</a></span><span class="t"><span class="nam">MINIC_EVAL</span> <span class="op">=</span> <span class="nam">os</span><span class="op">.</span><span class="nam">path</span><span class="op">.</span><span class="nam">join</span><span class="op">(</span>&nbsp;</span><span class="r"></span></p>
    <p id="t52" class="pln"><span class="n"><a href="#t52">52</a></span><span class="t"><span class="nam">HERE</span><span class="op">,</span> <span class="str">'..'</span><span class="op">,</span> <span class="str">'..'</span><span class="op">,</span> <span class="str">'TP03'</span><span class="op">,</span> <span class="str">'MiniC-type-interpret'</span><span class="op">,</span> <span class="str">'Main.py'</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t53" class="pln"><span class="n"><a href="#t53">53</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t54" class="pln"><span class="n"><a href="#t54">54</a></span><span class="t"><span class="com"># if 'COMPIL_MINIC_EVAL' in os.environ:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t55" class="pln"><span class="n"><a href="#t55">55</a></span><span class="t"><span class="com">#     MINIC_EVAL = os.environ['COMPIL_MINIC_EVAL']</span>&nbsp;</span><span class="r"></span></p>
    <p id="t56" class="pln"><span class="n"><a href="#t56">56</a></span><span class="t"><span class="com"># else:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t57" class="pln"><span class="n"><a href="#t57">57</a></span><span class="t"><span class="com">#     MINIC_EVAL = os.path.join(</span>&nbsp;</span><span class="r"></span></p>
    <p id="t58" class="pln"><span class="n"><a href="#t58">58</a></span><span class="t"><span class="com">#         HERE, '..', '..', 'TP03', 'MiniC-type-interpret', 'Main.py')</span>&nbsp;</span><span class="r"></span></p>
    <p id="t59" class="pln"><span class="n"><a href="#t59">59</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t60" class="pln"><span class="n"><a href="#t60">60</a></span><span class="t"><span class="com"># Avoid duplicates</span>&nbsp;</span><span class="r"></span></p>
    <p id="t61" class="run"><span class="n"><a href="#t61">61</a></span><span class="t"><span class="nam">ALL_IN_MEM_FILES</span> <span class="op">=</span> <span class="nam">list</span><span class="op">(</span><span class="nam">set</span><span class="op">(</span><span class="nam">ALL_FILES</span><span class="op">)</span> <span class="op">|</span> <span class="nam">set</span><span class="op">(</span><span class="nam">ALLOC_FILES</span><span class="op">)</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t62" class="run"><span class="n"><a href="#t62">62</a></span><span class="t"><span class="nam">ALL_IN_MEM_FILES</span><span class="op">.</span><span class="nam">sort</span><span class="op">(</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t63" class="run"><span class="n"><a href="#t63">63</a></span><span class="t"><span class="nam">ALL_FILES</span> <span class="op">=</span> <span class="nam">list</span><span class="op">(</span><span class="nam">set</span><span class="op">(</span><span class="nam">ALL_FILES</span><span class="op">)</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t64" class="run"><span class="n"><a href="#t64">64</a></span><span class="t"><span class="nam">ALL_FILES</span><span class="op">.</span><span class="nam">sort</span><span class="op">(</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t65" class="pln"><span class="n"><a href="#t65">65</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t66" class="run"><span class="n"><a href="#t66">66</a></span><span class="t"><span class="key">if</span> <span class="str">'TEST_FILES'</span> <span class="key">in</span> <span class="nam">os</span><span class="op">.</span><span class="nam">environ</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t67" class="mis show_mis"><span class="n"><a href="#t67">67</a></span><span class="t">    <span class="nam">ALLOC_FILES</span> <span class="op">=</span> <span class="nam">ALL_FILES</span>&nbsp;</span><span class="r"></span></p>
    <p id="t68" class="mis show_mis"><span class="n"><a href="#t68">68</a></span><span class="t">    <span class="nam">ALL_IN_MEM_FILES</span> <span class="op">=</span> <span class="nam">ALL_FILES</span>&nbsp;</span><span class="r"></span></p>
    <p id="t69" class="pln"><span class="n"><a href="#t69">69</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t70" class="pln"><span class="n"><a href="#t70">70</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t71" class="run"><span class="n"><a href="#t71">71</a></span><span class="t"><span class="key">class</span> <span class="nam">TestCodeGen</span><span class="op">(</span><span class="nam">TestExpectPragmas</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t72" class="pln"><span class="n"><a href="#t72">72</a></span><span class="t">    <span class="com"># Not in test_expect_pragma to get assertion rewritting</span>&nbsp;</span><span class="r"></span></p>
    <p id="t73" class="run"><span class="n"><a href="#t73">73</a></span><span class="t">    <span class="key">def</span> <span class="nam">assert_equal</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">actual</span><span class="op">,</span> <span class="nam">expected</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t74" class="run"><span class="n"><a href="#t74">74</a></span><span class="t">        <span class="key">if</span> <span class="nam">TYPECHECK_ONLY</span> <span class="key">and</span> <span class="nam">expected</span><span class="op">.</span><span class="nam">exitcode</span> <span class="op">==</span> <span class="num">0</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t75" class="pln"><span class="n"><a href="#t75">75</a></span><span class="t">            <span class="com"># Compiler does not fail => no output expected</span>&nbsp;</span><span class="r"></span></p>
    <p id="t76" class="mis show_mis"><span class="n"><a href="#t76">76</a></span><span class="t">            <span class="key">assert</span> <span class="nam">actual</span><span class="op">.</span><span class="nam">output</span> <span class="op">==</span> <span class="str">""</span><span class="op">,</span> <span class="xx">\</span>&nbsp;</span><span class="r"></span></p>
    <p id="t77" class="pln"><span class="n"><a href="#t77">77</a></span><span class="t">                <span class="str">"Compiler unexpectedly generated some output with --typecheck-only"</span>&nbsp;</span><span class="r"></span></p>
    <p id="t78" class="mis show_mis"><span class="n"><a href="#t78">78</a></span><span class="t">            <span class="key">assert</span> <span class="nam">actual</span><span class="op">.</span><span class="nam">exitcode</span> <span class="op">==</span> <span class="num">0</span><span class="op">,</span> <span class="xx">\</span>&nbsp;</span><span class="r"></span></p>
    <p id="t79" class="pln"><span class="n"><a href="#t79">79</a></span><span class="t">                <span class="str">"Compiler unexpectedly failed with --typecheck-only"</span>&nbsp;</span><span class="r"></span></p>
    <p id="t80" class="mis show_mis"><span class="n"><a href="#t80">80</a></span><span class="t">            <span class="key">return</span>&nbsp;</span><span class="r"></span></p>
    <p id="t81" class="run"><span class="n"><a href="#t81">81</a></span><span class="t">        <span class="key">if</span> <span class="nam">DISABLE_TYPECHECK</span> <span class="key">and</span> <span class="nam">expected</span><span class="op">.</span><span class="nam">exitcode</span> <span class="op">!=</span> <span class="num">0</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t82" class="pln"><span class="n"><a href="#t82">82</a></span><span class="t">            <span class="com"># Test should fail at typecheck, and we don't do</span>&nbsp;</span><span class="r"></span></p>
    <p id="t83" class="pln"><span class="n"><a href="#t83">83</a></span><span class="t">            <span class="com"># typechecking => nothing to check.</span>&nbsp;</span><span class="r"></span></p>
    <p id="t84" class="mis show_mis"><span class="n"><a href="#t84">84</a></span><span class="t">            <span class="nam">pytest</span><span class="op">.</span><span class="nam">skip</span><span class="op">(</span><span class="str">"Test that doesn't typecheck with --disable-typecheck"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t85" class="run"><span class="n"><a href="#t85">85</a></span><span class="t">        <span class="key">if</span> <span class="nam">expected</span><span class="op">.</span><span class="nam">output</span> <span class="key">is</span> <span class="key">not</span> <span class="key">None</span> <span class="key">and</span> <span class="nam">actual</span><span class="op">.</span><span class="nam">output</span> <span class="key">is</span> <span class="key">not</span> <span class="key">None</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t86" class="run"><span class="n"><a href="#t86">86</a></span><span class="t">            <span class="key">assert</span> <span class="nam">actual</span><span class="op">.</span><span class="nam">output</span> <span class="op">==</span> <span class="nam">expected</span><span class="op">.</span><span class="nam">output</span><span class="op">,</span> <span class="xx">\</span>&nbsp;</span><span class="r"></span></p>
    <p id="t87" class="pln"><span class="n"><a href="#t87">87</a></span><span class="t">                <span class="str">"Output of the program is incorrect."</span>&nbsp;</span><span class="r"></span></p>
    <p id="t88" class="run"><span class="n"><a href="#t88">88</a></span><span class="t">        <span class="key">assert</span> <span class="nam">actual</span><span class="op">.</span><span class="nam">exitcode</span> <span class="op">==</span> <span class="nam">expected</span><span class="op">.</span><span class="nam">exitcode</span><span class="op">,</span> <span class="xx">\</span>&nbsp;</span><span class="r"></span></p>
    <p id="t89" class="pln"><span class="n"><a href="#t89">89</a></span><span class="t">            <span class="str">"Exit code of the compiler is incorrect"</span>&nbsp;</span><span class="r"></span></p>
    <p id="t90" class="run"><span class="n"><a href="#t90">90</a></span><span class="t">        <span class="key">assert</span> <span class="nam">actual</span><span class="op">.</span><span class="nam">execcode</span> <span class="op">==</span> <span class="nam">expected</span><span class="op">.</span><span class="nam">execcode</span><span class="op">,</span> <span class="xx">\</span>&nbsp;</span><span class="r"></span></p>
    <p id="t91" class="pln"><span class="n"><a href="#t91">91</a></span><span class="t">            <span class="str">"Exit code of the execution (spike) is incorrect"</span>&nbsp;</span><span class="r"></span></p>
    <p id="t92" class="pln"><span class="n"><a href="#t92">92</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t93" class="run"><span class="n"><a href="#t93">93</a></span><span class="t">    <span class="key">def</span> <span class="nam">naive_alloc</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">file</span><span class="op">,</span> <span class="nam">info</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t94" class="run"><span class="n"><a href="#t94">94</a></span><span class="t">        <span class="key">return</span> <span class="nam">self</span><span class="op">.</span><span class="nam">compile_and_simulate</span><span class="op">(</span><span class="nam">file</span><span class="op">,</span> <span class="nam">info</span><span class="op">,</span> <span class="nam">reg_alloc</span><span class="op">=</span><span class="str">'naive'</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t95" class="pln"><span class="n"><a href="#t95">95</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t96" class="run"><span class="n"><a href="#t96">96</a></span><span class="t">    <span class="key">def</span> <span class="nam">all_in_mem</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">file</span><span class="op">,</span> <span class="nam">info</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t97" class="run"><span class="n"><a href="#t97">97</a></span><span class="t">        <span class="key">return</span> <span class="nam">self</span><span class="op">.</span><span class="nam">compile_and_simulate</span><span class="op">(</span><span class="nam">file</span><span class="op">,</span> <span class="nam">info</span><span class="op">,</span> <span class="nam">reg_alloc</span><span class="op">=</span><span class="str">'all_in_mem'</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t98" class="pln"><span class="n"><a href="#t98">98</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t99" class="run"><span class="n"><a href="#t99">99</a></span><span class="t">    <span class="key">def</span> <span class="nam">smart_alloc</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">file</span><span class="op">,</span> <span class="nam">info</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t100" class="run"><span class="n"><a href="#t100">100</a></span><span class="t">        <span class="key">return</span> <span class="nam">self</span><span class="op">.</span><span class="nam">compile_and_simulate</span><span class="op">(</span><span class="nam">file</span><span class="op">,</span> <span class="nam">info</span><span class="op">,</span> <span class="nam">reg_alloc</span><span class="op">=</span><span class="str">'smart'</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t101" class="pln"><span class="n"><a href="#t101">101</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t102" class="run"><span class="n"><a href="#t102">102</a></span><span class="t">    <span class="key">def</span> <span class="nam">run_with_gcc</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">file</span><span class="op">,</span> <span class="nam">info</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t103" class="run"><span class="n"><a href="#t103">103</a></span><span class="t">        <span class="key">return</span> <span class="nam">self</span><span class="op">.</span><span class="nam">compile_and_simulate</span><span class="op">(</span><span class="nam">file</span><span class="op">,</span> <span class="nam">info</span><span class="op">,</span> <span class="nam">reg_alloc</span><span class="op">=</span><span class="str">'gcc'</span><span class="op">,</span> <span class="nam">use_gcc</span><span class="op">=</span><span class="key">True</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t104" class="pln"><span class="n"><a href="#t104">104</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t105" class="run"><span class="n"><a href="#t105">105</a></span><span class="t">    <span class="key">def</span> <span class="nam">compile_with_gcc</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">file</span><span class="op">,</span> <span class="nam">output_name</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t106" class="run"><span class="n"><a href="#t106">106</a></span><span class="t">        <span class="nam">print</span><span class="op">(</span><span class="str">"Compiling with GCC..."</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t107" class="run"><span class="n"><a href="#t107">107</a></span><span class="t">        <span class="nam">result</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">run_command</span><span class="op">(</span>&nbsp;</span><span class="r"></span></p>
    <p id="t108" class="pln"><span class="n"><a href="#t108">108</a></span><span class="t">            <span class="op">[</span><span class="nam">ASM</span><span class="op">,</span> <span class="str">'-S'</span><span class="op">,</span> <span class="str">'-I.'</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t109" class="pln"><span class="n"><a href="#t109">109</a></span><span class="t">             <span class="str">'--output='</span> <span class="op">+</span> <span class="nam">output_name</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t110" class="pln"><span class="n"><a href="#t110">110</a></span><span class="t">             <span class="str">'-Werror'</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t111" class="pln"><span class="n"><a href="#t111">111</a></span><span class="t">             <span class="nam">file</span><span class="op">]</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t112" class="run"><span class="n"><a href="#t112">112</a></span><span class="t">        <span class="nam">print</span><span class="op">(</span><span class="nam">result</span><span class="op">.</span><span class="nam">output</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t113" class="run"><span class="n"><a href="#t113">113</a></span><span class="t">        <span class="nam">print</span><span class="op">(</span><span class="str">"Compiling with GCC... DONE"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t114" class="run"><span class="n"><a href="#t114">114</a></span><span class="t">        <span class="key">return</span> <span class="nam">result</span>&nbsp;</span><span class="r"></span></p>
    <p id="t115" class="pln"><span class="n"><a href="#t115">115</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t116" class="run"><span class="n"><a href="#t116">116</a></span><span class="t">    <span class="key">def</span> <span class="nam">compile_with_ours</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">file</span><span class="op">,</span> <span class="nam">output_name</span><span class="op">,</span> <span class="nam">reg_alloc</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t117" class="run"><span class="n"><a href="#t117">117</a></span><span class="t">        <span class="nam">print</span><span class="op">(</span><span class="str">"Compiling ..."</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t118" class="run"><span class="n"><a href="#t118">118</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">remove</span><span class="op">(</span><span class="nam">output_name</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t119" class="run"><span class="n"><a href="#t119">119</a></span><span class="t">        <span class="nam">alloc_opt</span> <span class="op">=</span> <span class="str">'--reg-alloc='</span> <span class="op">+</span> <span class="nam">reg_alloc</span>&nbsp;</span><span class="r"></span></p>
    <p id="t120" class="run"><span class="n"><a href="#t120">120</a></span><span class="t">        <span class="nam">out_opt</span> <span class="op">=</span> <span class="str">'--output='</span> <span class="op">+</span> <span class="nam">output_name</span>&nbsp;</span><span class="r"></span></p>
    <p id="t121" class="run"><span class="n"><a href="#t121">121</a></span><span class="t">        <span class="nam">cmd</span> <span class="op">=</span> <span class="op">[</span><span class="str">'python3'</span><span class="op">,</span> <span class="nam">MINIC_COMPILE</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t122" class="pln"><span class="n"><a href="#t122">122</a></span><span class="t">               <span class="nam">alloc_opt</span><span class="op">,</span> <span class="nam">out_opt</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t123" class="run"><span class="n"><a href="#t123">123</a></span><span class="t">        <span class="key">if</span> <span class="nam">DISABLE_TYPECHECK</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t124" class="run"><span class="n"><a href="#t124">124</a></span><span class="t">            <span class="nam">cmd</span> <span class="op">+=</span> <span class="op">[</span><span class="str">'--disable-typecheck'</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t125" class="run"><span class="n"><a href="#t125">125</a></span><span class="t">        <span class="key">if</span> <span class="nam">TYPECHECK_ONLY</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t126" class="mis show_mis"><span class="n"><a href="#t126">126</a></span><span class="t">            <span class="nam">cmd</span> <span class="op">+=</span> <span class="op">[</span><span class="str">'--typecheck-only'</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t127" class="run"><span class="n"><a href="#t127">127</a></span><span class="t">        <span class="nam">cmd</span> <span class="op">+=</span> <span class="op">[</span><span class="nam">file</span><span class="op">]</span>&nbsp;</span><span class="r"></span></p>
    <p id="t128" class="run"><span class="n"><a href="#t128">128</a></span><span class="t">        <span class="nam">result</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">run_command</span><span class="op">(</span><span class="nam">cmd</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t129" class="run"><span class="n"><a href="#t129">129</a></span><span class="t">        <span class="nam">print</span><span class="op">(</span><span class="str">' '</span><span class="op">.</span><span class="nam">join</span><span class="op">(</span><span class="nam">cmd</span><span class="op">)</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t130" class="run"><span class="n"><a href="#t130">130</a></span><span class="t">        <span class="nam">print</span><span class="op">(</span><span class="str">"Exited with status:"</span><span class="op">,</span> <span class="nam">result</span><span class="op">.</span><span class="nam">exitcode</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t131" class="run"><span class="n"><a href="#t131">131</a></span><span class="t">        <span class="nam">print</span><span class="op">(</span><span class="nam">result</span><span class="op">.</span><span class="nam">output</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t132" class="run"><span class="n"><a href="#t132">132</a></span><span class="t">        <span class="key">if</span> <span class="nam">result</span><span class="op">.</span><span class="nam">exitcode</span> <span class="op">==</span> <span class="num">4</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t133" class="run"><span class="n"><a href="#t133">133</a></span><span class="t">            <span class="key">if</span> <span class="str">"AllocationError"</span> <span class="key">in</span> <span class="nam">result</span><span class="op">.</span><span class="nam">output</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t134" class="run"><span class="n"><a href="#t134">134</a></span><span class="t">                <span class="key">if</span> <span class="nam">reg_alloc</span> <span class="op">==</span> <span class="str">'naive'</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t135" class="run"><span class="n"><a href="#t135">135</a></span><span class="t">                    <span class="nam">pytest</span><span class="op">.</span><span class="nam">skip</span><span class="op">(</span><span class="str">"Too big for the naive allocator"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t136" class="pln"><span class="n"><a href="#t136">136</a></span><span class="t">                <span class="key">else</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t137" class="mis show_mis"><span class="n"><a href="#t137">137</a></span><span class="t">                    <span class="key">raise</span> <span class="nam">Exception</span><span class="op">(</span><span class="str">"AllocationError should only happen "</span>&nbsp;</span><span class="r"></span></p>
    <p id="t138" class="pln"><span class="n"><a href="#t138">138</a></span><span class="t">                                    <span class="str">"for reg_alloc='naive'"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t139" class="mis show_mis"><span class="n"><a href="#t139">139</a></span><span class="t">            <span class="key">elif</span> <span class="op">(</span><span class="str">"NotImplementedError"</span> <span class="key">in</span> <span class="nam">result</span><span class="op">.</span><span class="nam">output</span> <span class="key">and</span>&nbsp;</span><span class="r"></span></p>
    <p id="t140" class="pln"><span class="n"><a href="#t140">140</a></span><span class="t">                  <span class="nam">SKIP_NOT_IMPLEMENTED</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t141" class="mis show_mis"><span class="n"><a href="#t141">141</a></span><span class="t">                <span class="nam">pytest</span><span class="op">.</span><span class="nam">skip</span><span class="op">(</span><span class="str">"Feature not implemented in this compiler"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t142" class="run"><span class="n"><a href="#t142">142</a></span><span class="t">        <span class="key">if</span> <span class="nam">result</span><span class="op">.</span><span class="nam">exitcode</span> <span class="op">!=</span> <span class="num">0</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t143" class="pln"><span class="n"><a href="#t143">143</a></span><span class="t">            <span class="com"># May either be a failing test or a test with expected</span>&nbsp;</span><span class="r"></span></p>
    <p id="t144" class="pln"><span class="n"><a href="#t144">144</a></span><span class="t">            <span class="com"># compilation failure (bad type, ...). Let the caller</span>&nbsp;</span><span class="r"></span></p>
    <p id="t145" class="pln"><span class="n"><a href="#t145">145</a></span><span class="t">            <span class="com"># do the assertion and decide:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t146" class="mis show_mis"><span class="n"><a href="#t146">146</a></span><span class="t">            <span class="key">return</span> <span class="nam">result</span>&nbsp;</span><span class="r"></span></p>
    <p id="t147" class="run"><span class="n"><a href="#t147">147</a></span><span class="t">        <span class="key">if</span> <span class="key">not</span> <span class="nam">TYPECHECK_ONLY</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t148" class="run"><span class="n"><a href="#t148">148</a></span><span class="t">            <span class="key">assert</span><span class="op">(</span><span class="nam">os</span><span class="op">.</span><span class="nam">path</span><span class="op">.</span><span class="nam">isfile</span><span class="op">(</span><span class="nam">output_name</span><span class="op">)</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t149" class="run"><span class="n"><a href="#t149">149</a></span><span class="t">        <span class="nam">print</span><span class="op">(</span><span class="str">"Compiling ... OK"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t150" class="run"><span class="n"><a href="#t150">150</a></span><span class="t">        <span class="key">return</span> <span class="nam">result</span>&nbsp;</span><span class="r"></span></p>
    <p id="t151" class="pln"><span class="n"><a href="#t151">151</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t152" class="run"><span class="n"><a href="#t152">152</a></span><span class="t">    <span class="key">def</span> <span class="nam">link_and_run</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">output_name</span><span class="op">,</span> <span class="nam">exec_name</span><span class="op">,</span> <span class="nam">info</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t153" class="run"><span class="n"><a href="#t153">153</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">remove</span><span class="op">(</span><span class="nam">exec_name</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t154" class="run"><span class="n"><a href="#t154">154</a></span><span class="t">        <span class="nam">cmd</span> <span class="op">=</span> <span class="op">[</span>&nbsp;</span><span class="r"></span></p>
    <p id="t155" class="pln"><span class="n"><a href="#t155">155</a></span><span class="t">            <span class="nam">ASM</span><span class="op">,</span> <span class="nam">output_name</span><span class="op">,</span> <span class="str">'libprint.s'</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t156" class="pln"><span class="n"><a href="#t156">156</a></span><span class="t">            <span class="str">'-o'</span><span class="op">,</span> <span class="nam">exec_name</span>&nbsp;</span><span class="r"></span></p>
    <p id="t157" class="pln"><span class="n"><a href="#t157">157</a></span><span class="t">        <span class="op">]</span> <span class="op">+</span> <span class="nam">info</span><span class="op">.</span><span class="nam">linkargs</span>&nbsp;</span><span class="r"></span></p>
    <p id="t158" class="run"><span class="n"><a href="#t158">158</a></span><span class="t">        <span class="nam">print</span><span class="op">(</span><span class="nam">info</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t159" class="run"><span class="n"><a href="#t159">159</a></span><span class="t">        <span class="nam">print</span><span class="op">(</span><span class="str">"Assembling and linking "</span> <span class="op">+</span> <span class="nam">output_name</span> <span class="op">+</span> <span class="str">": "</span> <span class="op">+</span> <span class="str">' '</span><span class="op">.</span><span class="nam">join</span><span class="op">(</span><span class="nam">cmd</span><span class="op">)</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t160" class="run"><span class="n"><a href="#t160">160</a></span><span class="t">        <span class="key">try</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t161" class="run"><span class="n"><a href="#t161">161</a></span><span class="t">            <span class="nam">subprocess</span><span class="op">.</span><span class="nam">check_output</span><span class="op">(</span><span class="nam">cmd</span><span class="op">,</span> <span class="nam">timeout</span><span class="op">=</span><span class="num">60</span><span class="op">,</span> <span class="nam">stderr</span><span class="op">=</span><span class="nam">subprocess</span><span class="op">.</span><span class="nam">STDOUT</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t162" class="mis show_mis"><span class="n"><a href="#t162">162</a></span><span class="t">        <span class="key">except</span> <span class="nam">subprocess</span><span class="op">.</span><span class="nam">CalledProcessError</span> <span class="key">as</span> <span class="nam">e</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t163" class="mis show_mis"><span class="n"><a href="#t163">163</a></span><span class="t">            <span class="nam">print</span><span class="op">(</span><span class="str">"Assembling failed:\n"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t164" class="mis show_mis"><span class="n"><a href="#t164">164</a></span><span class="t">            <span class="nam">print</span><span class="op">(</span><span class="nam">e</span><span class="op">.</span><span class="nam">output</span><span class="op">.</span><span class="nam">decode</span><span class="op">(</span><span class="op">)</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t165" class="mis show_mis"><span class="n"><a href="#t165">165</a></span><span class="t">            <span class="nam">print</span><span class="op">(</span><span class="str">"Assembler code below:\n"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t166" class="mis show_mis"><span class="n"><a href="#t166">166</a></span><span class="t">            <span class="nam">cat</span><span class="op">(</span><span class="nam">output_name</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t167" class="mis show_mis"><span class="n"><a href="#t167">167</a></span><span class="t">            <span class="nam">pytest</span><span class="op">.</span><span class="nam">fail</span><span class="op">(</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t168" class="run"><span class="n"><a href="#t168">168</a></span><span class="t">        <span class="key">assert</span><span class="op">(</span><span class="nam">os</span><span class="op">.</span><span class="nam">path</span><span class="op">.</span><span class="nam">isfile</span><span class="op">(</span><span class="nam">exec_name</span><span class="op">)</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t169" class="run"><span class="n"><a href="#t169">169</a></span><span class="t">        <span class="nam">sys</span><span class="op">.</span><span class="nam">stdout</span><span class="op">.</span><span class="nam">write</span><span class="op">(</span><span class="str">"Assembling and linking ... OK\n"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t170" class="run"><span class="n"><a href="#t170">170</a></span><span class="t">        <span class="key">try</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t171" class="run"><span class="n"><a href="#t171">171</a></span><span class="t">            <span class="nam">result</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">run_command</span><span class="op">(</span>&nbsp;</span><span class="r"></span></p>
    <p id="t172" class="pln"><span class="n"><a href="#t172">172</a></span><span class="t">                <span class="op">[</span><span class="nam">SIMU</span><span class="op">,</span> <span class="str">'pk'</span><span class="op">,</span> <span class="nam">exec_name</span><span class="op">]</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t173" class="pln"><span class="n"><a href="#t173">173</a></span><span class="t">                <span class="nam">scope</span><span class="op">=</span><span class="str">"runtime"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t174" class="run"><span class="n"><a href="#t174">174</a></span><span class="t">            <span class="nam">output</span> <span class="op">=</span> <span class="nam">re</span><span class="op">.</span><span class="nam">sub</span><span class="op">(</span><span class="str">r'bbl loader\r?\n'</span><span class="op">,</span> <span class="str">''</span><span class="op">,</span> <span class="nam">result</span><span class="op">.</span><span class="nam">output</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t175" class="run"><span class="n"><a href="#t175">175</a></span><span class="t">            <span class="key">return</span> <span class="nam">testinfo</span><span class="op">(</span><span class="nam">execcode</span><span class="op">=</span><span class="nam">result</span><span class="op">.</span><span class="nam">execcode</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t176" class="pln"><span class="n"><a href="#t176">176</a></span><span class="t">                            <span class="nam">exitcode</span><span class="op">=</span><span class="nam">result</span><span class="op">.</span><span class="nam">exitcode</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t177" class="pln"><span class="n"><a href="#t177">177</a></span><span class="t">                            <span class="nam">output</span><span class="op">=</span><span class="nam">output</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t178" class="pln"><span class="n"><a href="#t178">178</a></span><span class="t">                            <span class="nam">linkargs</span><span class="op">=</span><span class="op">[</span><span class="op">]</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t179" class="pln"><span class="n"><a href="#t179">179</a></span><span class="t">                            <span class="nam">skip_test_expected</span><span class="op">=</span><span class="key">False</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t180" class="mis show_mis"><span class="n"><a href="#t180">180</a></span><span class="t">        <span class="key">except</span> <span class="nam">subprocess</span><span class="op">.</span><span class="nam">TimeoutExpired</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t181" class="mis show_mis"><span class="n"><a href="#t181">181</a></span><span class="t">            <span class="nam">self</span><span class="op">.</span><span class="nam">fail</span><span class="op">(</span><span class="str">"Timeout executing program. Infinite loop in generated code?"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t182" class="pln"><span class="n"><a href="#t182">182</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t183" class="run"><span class="n"><a href="#t183">183</a></span><span class="t">    <span class="key">def</span> <span class="nam">compile_and_simulate</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">file</span><span class="op">,</span> <span class="nam">info</span><span class="op">,</span> <span class="nam">reg_alloc</span><span class="op">,</span> <span class="nam">use_gcc</span><span class="op">=</span><span class="key">False</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t184" class="run"><span class="n"><a href="#t184">184</a></span><span class="t">        <span class="nam">basename</span><span class="op">,</span> <span class="nam">_</span> <span class="op">=</span> <span class="nam">os</span><span class="op">.</span><span class="nam">path</span><span class="op">.</span><span class="nam">splitext</span><span class="op">(</span><span class="nam">file</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t185" class="run"><span class="n"><a href="#t185">185</a></span><span class="t">        <span class="nam">output_name</span> <span class="op">=</span> <span class="nam">basename</span> <span class="op">+</span> <span class="str">'-'</span> <span class="op">+</span> <span class="nam">reg_alloc</span> <span class="op">+</span> <span class="str">'.s'</span>&nbsp;</span><span class="r"></span></p>
    <p id="t186" class="run"><span class="n"><a href="#t186">186</a></span><span class="t">        <span class="key">if</span> <span class="nam">use_gcc</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t187" class="run"><span class="n"><a href="#t187">187</a></span><span class="t">            <span class="nam">result</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">compile_with_gcc</span><span class="op">(</span><span class="nam">file</span><span class="op">,</span> <span class="nam">output_name</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t188" class="run"><span class="n"><a href="#t188">188</a></span><span class="t">            <span class="key">if</span> <span class="nam">result</span><span class="op">.</span><span class="nam">exitcode</span> <span class="op">!=</span> <span class="num">0</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t189" class="pln"><span class="n"><a href="#t189">189</a></span><span class="t">                <span class="com"># We don't consider the exact exitcode, and ignore the</span>&nbsp;</span><span class="r"></span></p>
    <p id="t190" class="pln"><span class="n"><a href="#t190">190</a></span><span class="t">                <span class="com"># output (our error messages may be different from</span>&nbsp;</span><span class="r"></span></p>
    <p id="t191" class="pln"><span class="n"><a href="#t191">191</a></span><span class="t">                <span class="com"># GCC's)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t192" class="mis show_mis"><span class="n"><a href="#t192">192</a></span><span class="t">                <span class="key">return</span> <span class="nam">result</span><span class="op">.</span><span class="nam">_replace</span><span class="op">(</span><span class="nam">exitcode</span><span class="op">=</span><span class="num">1</span><span class="op">,</span>&nbsp;</span><span class="r"></span></p>
    <p id="t193" class="pln"><span class="n"><a href="#t193">193</a></span><span class="t">                                       <span class="nam">output</span><span class="op">=</span><span class="key">None</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t194" class="pln"><span class="n"><a href="#t194">194</a></span><span class="t">        <span class="key">else</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t195" class="run"><span class="n"><a href="#t195">195</a></span><span class="t">            <span class="nam">result</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">compile_with_ours</span><span class="op">(</span><span class="nam">file</span><span class="op">,</span> <span class="nam">output_name</span><span class="op">,</span> <span class="nam">reg_alloc</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t196" class="run"><span class="n"><a href="#t196">196</a></span><span class="t">        <span class="key">if</span> <span class="op">(</span><span class="nam">TYPECHECK_ONLY</span> <span class="key">or</span>&nbsp;</span><span class="r"></span></p>
    <p id="t197" class="pln"><span class="n"><a href="#t197">197</a></span><span class="t">                <span class="nam">reg_alloc</span> <span class="op">==</span> <span class="str">'none'</span> <span class="key">or</span>&nbsp;</span><span class="r"></span></p>
    <p id="t198" class="pln"><span class="n"><a href="#t198">198</a></span><span class="t">                <span class="nam">info</span><span class="op">.</span><span class="nam">exitcode</span> <span class="op">!=</span> <span class="num">0</span> <span class="key">or</span> <span class="nam">result</span><span class="op">.</span><span class="nam">exitcode</span> <span class="op">!=</span> <span class="num">0</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t199" class="pln"><span class="n"><a href="#t199">199</a></span><span class="t">            <span class="com"># Either the result is meaningless, or we already failed</span>&nbsp;</span><span class="r"></span></p>
    <p id="t200" class="pln"><span class="n"><a href="#t200">200</a></span><span class="t">            <span class="com"># and don't need to go any further:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t201" class="mis show_mis"><span class="n"><a href="#t201">201</a></span><span class="t">            <span class="key">return</span> <span class="nam">result</span>&nbsp;</span><span class="r"></span></p>
    <p id="t202" class="pln"><span class="n"><a href="#t202">202</a></span><span class="t">        <span class="com"># Only executable code past this point.</span>&nbsp;</span><span class="r"></span></p>
    <p id="t203" class="run"><span class="n"><a href="#t203">203</a></span><span class="t">        <span class="nam">exec_name</span> <span class="op">=</span> <span class="nam">basename</span> <span class="op">+</span> <span class="str">'.riscv'</span>&nbsp;</span><span class="r"></span></p>
    <p id="t204" class="run"><span class="n"><a href="#t204">204</a></span><span class="t">        <span class="key">return</span> <span class="nam">self</span><span class="op">.</span><span class="nam">link_and_run</span><span class="op">(</span><span class="nam">output_name</span><span class="op">,</span> <span class="nam">exec_name</span><span class="op">,</span> <span class="nam">info</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t205" class="pln"><span class="n"><a href="#t205">205</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t206" class="run"><span class="n"><a href="#t206">206</a></span><span class="t">    <span class="op">@</span><span class="nam">pytest</span><span class="op">.</span><span class="nam">mark</span><span class="op">.</span><span class="nam">parametrize</span><span class="op">(</span><span class="str">'filename'</span><span class="op">,</span> <span class="nam">ALL_FILES</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t207" class="pln"><span class="n"><a href="#t207">207</a></span><span class="t">    <span class="key">def</span> <span class="nam">test_expect</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">filename</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t208" class="pln"><span class="n"><a href="#t208">208</a></span><span class="t">        <span class="str">"""Test the EXPECTED annotations in test files by launching the</span>&nbsp;</span><span class="r"></span></p>
    <p id="t209" class="pln"><span class="n"><a href="#t209">209</a></span><span class="t"><span class="str">        program with GCC."""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t210" class="run"><span class="n"><a href="#t210">210</a></span><span class="t">        <span class="nam">expect</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_expect</span><span class="op">(</span><span class="nam">filename</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t211" class="run"><span class="n"><a href="#t211">211</a></span><span class="t">        <span class="key">if</span> <span class="nam">expect</span><span class="op">.</span><span class="nam">skip_test_expected</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t212" class="mis show_mis"><span class="n"><a href="#t212">212</a></span><span class="t">            <span class="nam">pytest</span><span class="op">.</span><span class="nam">skip</span><span class="op">(</span><span class="str">"Skipping test because it contains SKIP TEST EXPECTED"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t213" class="run"><span class="n"><a href="#t213">213</a></span><span class="t">        <span class="key">if</span> <span class="nam">expect</span><span class="op">.</span><span class="nam">exitcode</span> <span class="op">!=</span> <span class="num">0</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t214" class="pln"><span class="n"><a href="#t214">214</a></span><span class="t">            <span class="com"># GCC is more permissive than us, so trying to compile an</span>&nbsp;</span><span class="r"></span></p>
    <p id="t215" class="pln"><span class="n"><a href="#t215">215</a></span><span class="t">            <span class="com"># incorrect program would bring us no information (it may</span>&nbsp;</span><span class="r"></span></p>
    <p id="t216" class="pln"><span class="n"><a href="#t216">216</a></span><span class="t">            <span class="com"># compile, or fail with a different message...)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t217" class="mis show_mis"><span class="n"><a href="#t217">217</a></span><span class="t">            <span class="nam">pytest</span><span class="op">.</span><span class="nam">skip</span><span class="op">(</span><span class="str">"Not testing the expected value for tests expecting exitcode==1"</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t218" class="run"><span class="n"><a href="#t218">218</a></span><span class="t">        <span class="nam">gcc_result</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">run_with_gcc</span><span class="op">(</span><span class="nam">filename</span><span class="op">,</span> <span class="nam">expect</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t219" class="run"><span class="n"><a href="#t219">219</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">assert_equal</span><span class="op">(</span><span class="nam">gcc_result</span><span class="op">,</span> <span class="nam">expect</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t220" class="pln"><span class="n"><a href="#t220">220</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t221" class="run"><span class="n"><a href="#t221">221</a></span><span class="t">    <span class="op">@</span><span class="nam">pytest</span><span class="op">.</span><span class="nam">mark</span><span class="op">.</span><span class="nam">parametrize</span><span class="op">(</span><span class="str">'filename'</span><span class="op">,</span> <span class="nam">ALL_FILES</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t222" class="pln"><span class="n"><a href="#t222">222</a></span><span class="t">    <span class="key">def</span> <span class="nam">test_naive_alloc</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">filename</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t223" class="run"><span class="n"><a href="#t223">223</a></span><span class="t">        <span class="nam">expect</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_expect</span><span class="op">(</span><span class="nam">filename</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t224" class="run"><span class="n"><a href="#t224">224</a></span><span class="t">        <span class="nam">naive</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">naive_alloc</span><span class="op">(</span><span class="nam">filename</span><span class="op">,</span> <span class="nam">expect</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t225" class="run"><span class="n"><a href="#t225">225</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">assert_equal</span><span class="op">(</span><span class="nam">naive</span><span class="op">,</span> <span class="nam">expect</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t226" class="pln"><span class="n"><a href="#t226">226</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t227" class="run"><span class="n"><a href="#t227">227</a></span><span class="t">    <span class="op">@</span><span class="nam">pytest</span><span class="op">.</span><span class="nam">mark</span><span class="op">.</span><span class="nam">parametrize</span><span class="op">(</span><span class="str">'filename'</span><span class="op">,</span> <span class="nam">ALL_IN_MEM_FILES</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t228" class="pln"><span class="n"><a href="#t228">228</a></span><span class="t">    <span class="key">def</span> <span class="nam">test_alloc_mem</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">filename</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t229" class="run"><span class="n"><a href="#t229">229</a></span><span class="t">        <span class="nam">expect</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_expect</span><span class="op">(</span><span class="nam">filename</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t230" class="run"><span class="n"><a href="#t230">230</a></span><span class="t">        <span class="nam">actual</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">all_in_mem</span><span class="op">(</span><span class="nam">filename</span><span class="op">,</span> <span class="nam">expect</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t231" class="run"><span class="n"><a href="#t231">231</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">assert_equal</span><span class="op">(</span><span class="nam">actual</span><span class="op">,</span> <span class="nam">expect</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t232" class="pln"><span class="n"><a href="#t232">232</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t233" class="run"><span class="n"><a href="#t233">233</a></span><span class="t">    <span class="op">@</span><span class="nam">pytest</span><span class="op">.</span><span class="nam">mark</span><span class="op">.</span><span class="nam">parametrize</span><span class="op">(</span><span class="str">'filename'</span><span class="op">,</span> <span class="nam">ALLOC_FILES</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t234" class="pln"><span class="n"><a href="#t234">234</a></span><span class="t">    <span class="key">def</span> <span class="nam">test_smart_alloc</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">filename</span><span class="op">)</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t235" class="pln"><span class="n"><a href="#t235">235</a></span><span class="t">        <span class="str">"""Generate code with smart allocation."""</span>&nbsp;</span><span class="r"></span></p>
    <p id="t236" class="run"><span class="n"><a href="#t236">236</a></span><span class="t">        <span class="nam">expect</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">get_expect</span><span class="op">(</span><span class="nam">filename</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t237" class="run"><span class="n"><a href="#t237">237</a></span><span class="t">        <span class="nam">actual</span> <span class="op">=</span> <span class="nam">self</span><span class="op">.</span><span class="nam">smart_alloc</span><span class="op">(</span><span class="nam">filename</span><span class="op">,</span> <span class="nam">expect</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t238" class="run"><span class="n"><a href="#t238">238</a></span><span class="t">        <span class="nam">self</span><span class="op">.</span><span class="nam">assert_equal</span><span class="op">(</span><span class="nam">actual</span><span class="op">,</span> <span class="nam">expect</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
    <p id="t239" class="pln"><span class="n"><a href="#t239">239</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t240" class="pln"><span class="n"><a href="#t240">240</a></span><span class="t">&nbsp;</span><span class="r"></span></p>
    <p id="t241" class="run"><span class="n"><a href="#t241">241</a></span><span class="t"><span class="key">if</span> <span class="nam">__name__</span> <span class="op">==</span> <span class="str">'__main__'</span><span class="op">:</span>&nbsp;</span><span class="r"></span></p>
    <p id="t242" class="mis show_mis"><span class="n"><a href="#t242">242</a></span><span class="t">    <span class="nam">pytest</span><span class="op">.</span><span class="nam">main</span><span class="op">(</span><span class="nam">sys</span><span class="op">.</span><span class="nam">argv</span><span class="op">)</span>&nbsp;</span><span class="r"></span></p>
</div>
<div id="footer">
    <div class="content">
        <p>
            <a class="nav" href="index.html">&#xab; index</a> &nbsp; &nbsp; <a class="nav" href="https://coverage.readthedocs.io">coverage.py v5.0.3</a>,
            created at 2020-01-26 23:08
        </p>
    </div>
</div>
</body>
</html>
